/***************************************************************************
                          filelistview.h  -  description
                             -------------------
    begin                : Wed Aug 11 1999
    copyright            : (C) 1999 by Arjan Buursink
    email                : buursink@casema.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef FILELISTVIEW_H
#define FILELISTVIEW_H

#include <qlistview.h>
#include <groupviewwidget.h>
#include "filegroupext.h"

/**
  *@author Arjan Buursink
  */

class FileListView : public QListView  {
	Q_OBJECT
public:
	FileListView(QWidget *parent=0,const char *name=0);
	~FileListView();
 	void init();
	void setFileGroup(FileGroupBase *);
	FileGroupBase * fileGroup(){return fgroup;};
	QString fileName(QListViewItem *);
	GroupViewWidget * groupViewWidget() {return _groupViewWidget;};
public slots:
	void markAll();
	void deMarkAll();
private:
	FileGroupBase * fgroup;
	void viewportMousePressEvent(QMouseEvent*);
	bool isSafe(QString);
	void setupItem(QListViewItem *, unsigned int);
	GroupViewWidget * _groupViewWidget;
signals:
	void fileSelectionChanged(FileGroupBase*);
};

#endif

