/***************************************************************************
                          uninstalldialog.h  -  description
                             -------------------
    begin                : Wed Nov 22 2000
    copyright            : (C) 2000 by Arjan Buursink
    email                : buursink@casema.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UNINSTALLDIALOG_H
#define UNINSTALLDIALOG_H

#include <qlist.h>
#include <klocale.h>

#include <uninstallbase.h>
#include "batch.h"
#include "grouptree.h"
#include "buttonlabelwidget2.h"

/**
  *@author Arjan Buursink
  */

class UninstallDialog : public UninstallBase  {
	Q_OBJECT
public: 
	UninstallDialog(GroupTree *);
	~UninstallDialog();
	Batch * batch;
	GroupTree * groupTree() {return _groupTree;};
private:
	GroupTree * _groupTree;
	QList<FileGroupExt> *grouplist;
	ButtonLabelWidget2 * batchProgress;
	unsigned int counter;
	void accept();
	void reject();
private slots:
	void slotProcessExited();
	void slotBatchExited();
};

#endif
